;;; DO NOT MODIFY THIS FILE -*- coding: raw-text-unix -*-
;;;###coding system: raw-text-unix
(if (featurep 'efs-custom-defines) (error "Feature efs-custom-defines already loaded"))

;;;### (autoloads (efs-dumb-apollo-unix-regexp efs-netware-host-regexp efs-nos-ve-host-regexp efs-cms-knet-host-regexp efs-plan9-host-regexp efs-ms-unix-host-regexp efs-guardian-host-regexp efs-hell-host-regexp efs-vos-host-regexp efs-os2-host-regexp efs-dos-distinct-host-regexp efs-ka9q-host-regexp efs-mpe-host-regexp efs-tops-20-host-regexp efs-mvs-host-regexp efs-apollo-unix-host-regexp efs-dos-host-regexp efs-super-dumb-unix-host-regexp efs-dumb-unix-host-regexp efs-unix-host-regexp efs-next-unix-host-regexp efs-bsd-unix-host-regexp efs-sysV-unix-host-regexp efs-ti-twenex-host-regexp efs-ti-explorer-host-regexp efs-mts-host-regexp efs-cms-host-regexp efs-vms-host-regexp efs-hooks efs-parameters efs-programs efs-gateways efs-auto-save efs-behavior efs) "efs-cu" "efs/efs-cu.el")
(defconst custom-define-current-source-file "efs-cu.el")

(defgroup efs nil "Transparent ftp access." :group 'files)

(defgroup efs-behavior nil "User-visible aspects of EFS." :prefix "efs-" :group 'efs)

(defgroup efs-auto-save nil "EFS interaction with auto-save." :prefix "efs-" :group 'efs)

(defgroup efs-gateways nil "Using EFS via an ftp gateway." :prefix "efs-" :group 'efs)

(defgroup efs-programs nil "External programs used by EFS." :prefix "efs-" :group 'efs)

(defgroup efs-parameters nil "Behind-the-scenes parameters of EFS." :prefix "efs-" :group 'efs)

(defgroup efs-hooks nil "Hooks for EFS." :prefix "efs-" :group 'efs)

(defcustom efs-vms-host-regexp nil "\
Regexp to match the names of hosts running VMS." :group 'efs-parameters :type '(choice (const nil) regexp))

(defcustom efs-cms-host-regexp nil "\
Regexp to match the names of hosts running CMS." :group 'efs-parameters :type '(choice (const nil) regexp))

(defcustom efs-mts-host-regexp nil "\
Regexp to match the names of hosts running MTS." :group 'efs-parameters :type '(choice (const nil) regexp))

(defcustom efs-ti-explorer-host-regexp nil "\
Regexp to match the names of hosts running TI-EXPLORER.
These are lisp machines." :group 'efs-parameters :type '(choice (const nil) regexp))

(defcustom efs-ti-twenex-host-regexp nil "\
Regexp to match the names of hosts running TI-TWENEX.
These are lisp machines, and this should not be confused with DEC's TOPS-20." :group 'efs-parameters :type '(choice (const nil) regexp))

(defcustom efs-sysV-unix-host-regexp nil "\
Regexp to match the names of sysV unix hosts.
These are defined to be unix hosts which mark symlinks
with a @ in an ls -lF listing." :group 'efs-parameters :type '(choice (const nil) regexp))

(defcustom efs-bsd-unix-host-regexp nil "\
Regexp to match the names of bsd unix hosts.
These are defined to be unix hosts which do not mark symlinks
with a @ in an ls -lF listing." :group 'efs-parameters :type '(choice (const nil) regexp))

(defcustom efs-next-unix-host-regexp nil "\
Regexp to match names of NeXT unix hosts.
These are defined to be unix hosts which put a @ after the
destination of a symlink when doing ls -lF listing." :group 'efs-parameters :type '(choice (const nil) regexp))

(defcustom efs-unix-host-regexp nil "\
Regexp to match names of unix hosts.
I you know which type of unix, it is much better to set that regexp instead." :group 'efs-parameters :type '(choice (const nil) regexp))

(defcustom efs-dumb-unix-host-regexp nil "\
Regexp to match names of unix hosts which do not take ls switches.
For these hosts we use the \"dir\" command." :group 'efs-parameters :type '(choice (const nil) regexp))

(defcustom efs-super-dumb-unix-host-regexp nil "\
Regexp to match names of unix hosts with FTP servers that cannot do a PWD.
It is also assumed that these hosts do not accept ls switches, whether
or not this is actually true." :group 'efs-parameters :type '(choice (const nil) regexp))

(defcustom efs-dos-host-regexp nil "\
Regexp to match names of hosts running DOS." :group 'efs-parameters :type '(choice (const nil) regexp))

(defcustom efs-apollo-unix-host-regexp nil "\
Regexp to match names of apollo unix hosts running Apollo's Domain.
For these hosts we don't short-circuit //'s immediately following 
\"/user@host:\"" :group 'efs-parameters :type '(choice (const nil) regexp))

(defcustom efs-mvs-host-regexp nil "\
Regexp to match names of hosts running MVS." :group 'efs-parameters :type '(choice (const nil) regexp))

(defcustom efs-tops-20-host-regexp nil "\
Regexp to match names of hosts runninf TOPS-20." :group 'efs-parameters :type '(choice (const nil) regexp))

(defcustom efs-mpe-host-regexp nil "\
Regexp to match hosts running the MPE operating system." :group 'efs-parameters :type '(choice (const nil) regexp))

(defcustom efs-ka9q-host-regexp nil "\
Regexp to match hosts using the ka9q ftp server. 
These may actually be running one of DOS, LINUX, or unix." :group 'efs-parameters :type '(choice (const nil) regexp))

(defcustom efs-dos-distinct-host-regexp nil "\
Regexp to match DOS hosts using the Distinct FTP server.
These are not treated as DOS hosts with a special listing format, because
the Distinct FTP server uses unix-style path syntax." :group 'efs-parameters :type '(choice (const nil) regexp))

(defcustom efs-os2-host-regexp nil "\
Regexp to match names of hosts running OS/2." :group 'efs-parameters :type '(choice (const nil) regexp))

(defcustom efs-vos-host-regexp nil "\
Regexp to match hosts running the VOS operating system." :group 'efs-parameters :type '(choice (const nil) regexp))

(defcustom efs-hell-host-regexp nil "\
Regexp to match hosts using the hellsoft ftp server.
These map be either DOS PC's or Macs." :group 'efs-parameters :type '(choice (const nil) regexp))

(defcustom efs-guardian-host-regexp nil "\
Regexp to match hosts running Tandem's guardian operating system." :group 'efs-parameters :type '(choice (const nil) regexp))

(defcustom efs-ms-unix-host-regexp nil "\
Regexp to match hosts using the Microsoft FTP server in unix mode." :group 'efs-parameters :type '(choice (const nil) regexp))

(defcustom efs-plan9-host-regexp nil "\
Regexp to match hosts running ATT's Plan 9 operating system." :group 'efs-parameters :type '(choice (const nil) regexp))

(defcustom efs-cms-knet-host-regexp nil "\
Regexp to match hosts running the CMS KNET FTP server." :group 'efs-parameters :type '(choice (const nil) regexp))

(defcustom efs-nos-ve-host-regexp nil "\
Regexp to match hosts running NOS/VE." :group 'efs-parameters :type '(choice (const nil) regexp))

(defcustom efs-netware-host-regexp nil "\
Regexp to match hosts running Novell Netware." :group 'efs-parameters :type '(choice (const nil) regexp))

(defcustom efs-dumb-apollo-unix-regexp nil "\
Regexp to match dumb hosts running Apollo's Domain.
These are hosts which do not accept switches to ls over FTP." :group 'efs-parameters :type '(choice (const nil) regexp))

;;;***

;;;### (autoloads (efs-load-hook efs-ftp-startup-function-alist efs-ftp-startup-hook efs-use-passive-mode efs-debug-ftp-connection efs-ftp-buffer-format efs-suppress-abort-recursive-edit-and-then efs-pty-check-retry-time efs-pty-check-threshold efs-retry-time efs-ftp-buffer-expire-time efs-expire-ftp-buffers efs-maximize-idle efs-verify-modtime-host-regexp efs-verify-anonymous-modtime efs-fancy-buffer-names efs-buffer-name-case efs-compute-remote-buffer-file-truename efs-quote-local-paths efs-slash-local-paths efs-quote-local-paths efs-nlist-cmd efs-ding-on-chmod-failure efs-ding-on-umask-failure efs-umask efs-anonymous-umask efs-root-umask efs-local-apollo-unix efs-short-circuit-to-remote-root efs-short-circuit efs-auto-save-remotely efs-auto-save efs-backup-by-copying efs-make-backup-files efs-umask-command efs-remote-shell-takes-user efs-use-remote-shell-internally efs-remote-shell-file-name efs-nslookup-threshold efs-nslookup-on-connect efs-nslookup-program efs-ftp-explicit-empty-file-name efs-ftp-broken-quote efs-ftp-flush-command efs-ftp-prompt-regexp efs-ftp-program-args efs-ftp-program-name efs-ftp-activity-function efs-show-host-type-in-dired efs-mode-line-format efs-ls-cache-max efs-max-ftp-buffer-size efs-message-interval efs-verbose efs-incoming-binary-hm-size efs-hash-mark-size efs-send-hash efs-treat-crlf-as-nl efs-prompt-for-transfer-type efs-text-file-name-regexp efs-36-bit-binary-file-name-regexp efs-binary-file-host-regexp efs-binary-file-name-regexp efs-high-security-hosts efs-generate-anonymous-password efs-tmp-name-template efs-gateway-ftp-prompt-regexp efs-gateway-mounted-dirs-alist efs-gateway-tmp-name-template efs-gateway-incoming-binary-hm-size efs-gateway-hash-mark-size efs-gateway-type efs-gateway-host efs-ftp-local-host-regexp efs-local-host-regexp) "efs" "efs/efs.el")
(defconst custom-define-current-source-file "efs.el")

(defcustom efs-local-host-regexp ".*" "\
Regexp to match names of local hosts.
These are hosts to which it is possible to obtain a direct internet
connection.  Even if the host is accessible by a very transparent FTP gateway,
it does not qualify as a local host.  The test to determine if machine A is
local to your machine is if it is possible to ftp from A _back_ to your
local machine.  Also, open-network-stream must be able to reach the host
in question." :type 'regexp :group 'efs-gateways)

(defcustom efs-ftp-local-host-regexp ".*" "\
Regexp to match the names of hosts reachable by a direct ftp connection.
This regexp should match the names of hosts which can be reached using ftp,
without requiring any explicit connection to a gateway. If you have a smart
ftp client which is able to transparently go through a gateway, this will
differ from `efs-local-host-regexp'." :type 'regexp :group 'efs-gateways)

(defcustom efs-gateway-host nil "\
If non-nil, this must be the name of your ftp gateway machine.
If your net world is divided into two domains according to
`efs-local-ftp-host-regexp', set this variable to the name of the
gateway machine." :type '(choice string (const nil)) :group 'efs-gateways)

(defcustom efs-gateway-type nil "\
Specifies which type of gateway you wish efs to use.
This should be a list, the first element of which is a symbol denoting the
gateway type, and following elements give data on how to use the gateway.

The following possibilities are supported:

  '(local FTP-PROGRAM FTP-PROGRAM-ARGS)
  This means that your local host is itself the gateway.  However,
  you need to run a special FTP client to access outside hosts.
  FTP-PROGRAM should be the name of this FTP client,  and FTP-PROGRAM-ARGS
  is a list of arguments to pass to it (probably set this to the value of
  efs-ftp-program-args <V>).  Note that if your gateway is of this type,
  then you would set efs-gateway-host to nil.

  '(proxy FTP-PROGRAM FTP-PROGRAM-ARGS)
  This indicates that your gateway works by first FTP'ing to it, and
  then giving a  USER command of the form \"USER <username>@<host>\".
  FTP-PROGRAM is the FTP program to use to connect to the gateway; this
  is most likely \"ftp\".  FTP-PROGRAM-ARGS is a list of arguments to
  pass to it.  You likely want this to be set to the value of
  efs-ftp-program-args <V>.  If the connection to the gateway FTP server
  is to be on a port different from 21, set efs-gateway-host to
  \"<host>#<port>\".

  '(sidewinder FTP-PROGRAM FTP-PROGRAM-ARGS)
  This is for sidewinder proxies. We first FTP to the proxy, and give
  a USER command of the form \"USER <username>@<host>\". This should
  now connect to <host>. Now we send another USER command \"USER <user>\".

  '(raptor FTP-PROGRAM FTP-PROGRAM-ARGS USER)
  This is for the gateway called raptor by Eagle.  After connecting to the
  the gateway, the command \"user <user>@host USER\" is issued to login
  as <user> on <host>, where USER is an authentication username for the
  gateway.  After issuing the password for the remote host, efs will
  send the password for USER on efs-gateway-host <V> as an account command.

 '(interlock FTP-PROGRAM FTP-PROGRAM-ARGS)
  This is for the interlock gateway.  The exact login sequence is to
  connect to the gateway specified by efs-gateway-host <V>, send the
  gateway password with a PASS command, send the command
  \"user <user>@<host>\" to connect to remote host <host> as user <user>,
  and finally to send the password for <user> on <host> with a second
  PASS command.

  '(kerberos FTP-PROGRAM FTP-PROGRAM-ARGS KINIT-PROGRAM KINIT-PROGRAM-ARGS)
  This is for the kerberos gateway where you need to run a program (kinit) to
  obtain a ticket for gateway authroization first.  FTP-PROGRAM should be
  the name of the FTP client that you use to connect to the gateway.  This
  may likely be \"iftp\".  FTP-PROGRAM-ARGS are the arguments that you need
  to pass to FTP-PROGRAM.  This is probably the value of
  efs-ftp-program-args <V>.  KINIT-PROGRAM is the name of the program to
  run in order to obtain a ticket.  This is probably \"kinit\".
  KINIT-PROGRAM-ARGS is a list og strings indicating any arguments that you
  need to pass to KINIT-PROGRAM.  Most likely this is nil.

  '(remsh GATEWAY-PROGRAM GATEWAY-PROGRAM-ARGS FTP-PROGRAM FTP-PROGRAM-ARGS)
  This indicates that you wish to run FTP on your gateway using a remote shell.
  GATEWAY-PROGRAM is the name of the program to use to start a remote shell.
  It is assumed that it is not necessary to provide a password to start
  this remote shell.  Likely values are \"remsh\" or \"rsh\".
  GATEWAY-PROGRAM-ARGS is a list of arguments to pass to GATEWAY-PROGRAM.
  FTP-PROGRAM is the name of the FTP program on the gateway.  A likely setting
  of this is \"ftp\".  FTP-PROGRAM-ARGS is a list of arguments to pass to
  FTP-PROGRAM.  Most likely these should be set to the value of
  efs-ftp-program-args <V>.

  '(interactive GATEWAY-PROGRAM GATEWAY-PROGRAM-ARGS FTP-PROGRAM
      FTP-PROGRAM-ARGS)
  This indicates that you need to start an interactive login on your gatway,
  using rlogin, telnet, or something similar.  GATEWAY-PROGRAM is the name
  of the program to use to log in to the gateway, and GATEWAY-PROGRAM-ARGS
  is a list of arguments to pass to it.  FTP-PROGRAM is the name of the FTP
  program on the gateway.  A likely setting for this variable would be
  \"exec ftp\".  FTP-PROGRAM-ARGS is a list of arguments to pass
  to FTP-PROGRAM.  You probably want to set these to the same value as
  efs-ftp-program-args <V>.  If you are using this option, read the
  documentation at the top of efs-gwp.el, and see
  efs-gwp-setup-term-command <V>." :type '(choice (const nil) (list :tag "Local" :value (local "" nil) (const :format "" local) (file :tag "FTP Program") (repeat :tag "FTP Program Args" string)) (list :tag "Proxy" :value (proxy "" nil) (const :format "" proxy) (file :tag "FTP Program") (repeat :tag "FTP Program Args" string)) (list :tag "Sidewinder" :value (sidewinder "" nil) (const :format "" sidewinder) (file :tag "FTP Program") (repeat :tag "FTP Program Args" string)) (list :tag "Raptor" :value (raptor "" nil "") (const :format "" raptor) (file :tag "FTP Program") (repeat :tag "FTP Program Args" string) (string :tag "User")) (list :tag "Interlock" :value (interlock "" nil) (const :format "" interlock) (file :tag "FTP Program") (repeat :tag "FTP Program Args" string)) (list :tag "Kerberos" :value (kerberos "" nil "" nil) (const :format "" kerberos) (file :tag "FTP Program") (repeat :tag "FTP Program Args" string) (file :tag "KINIT Program") (repeat :tag "KINIT Program Args" string)) (list :tag "Remsh" :value (remsh "" nil "" nil) (const :format "" remsh) (file :tag "Gateway Program") (repeat :tag "Gateway Program Args" string) (file :tag "FTP Program") (repeat :tag "FTP Program Args" string)) (list :tag "Interactive" :value (interactive "" nil "" nil) (const :format "" interactive) (file :tag "Gateway Program") (repeat :tag "Gateway Program Args" string) (file :tag "FTP Program") (repeat :tag "FTP Program Args" string))) :group 'efs-gateways)

(defcustom efs-gateway-hash-mark-size nil "\
*Value of `efs-hash-mark-size' for FTP clients on `efs-gateway-host'.
See the documentation of these variables for more information." :type '(choice integer (const nil)) :group 'efs-gateways)

(defcustom efs-gateway-incoming-binary-hm-size nil "\
*Value of `efs-incoming-binary-hm-size' for `efs-gateway-host'.
See documentation of these variables for more information." :type '(choice integer (const nil)) :group 'efs-gateways)

(defcustom efs-gateway-tmp-name-template "/tmp/efs" "\
Template used to create temporary files when ftp-ing through a gateway.
This should be the name of the file on the gateway, and not necessarily
the name on the local host." :type 'string :group 'efs-gateways)

(defcustom efs-gateway-mounted-dirs-alist nil "\
An alist of directories cross-mounted between the gateway and local host.
Each entry is of the form ( DIR1 . DIR2 ), where DIR1 is the name of the
directory on the local host, and DIR2 is its name on the remote host. Both
DIR1 and DIR2 must be specified in directory syntax, i.e. end in a slash.
Note that we will assume that subdirs of DIR1 and DIR2 are also accessible
on both machines." :type '(repeat (cons string string)) :group 'efs-gateways)

(defcustom efs-gateway-ftp-prompt-regexp "^\\(ftp\\|Ftp\\|FTP\\)> *" "\
*Regular expression to match the prompt of the gateway FTP client." :type 'regexp :group 'efs-gateways)

(defcustom efs-tmp-name-template (concat (cond ((fboundp 'temp-directory) (if (eq system-type 'windows-nt) (replace-in-string (temp-directory) "\\\\" "/") (temp-directory))) ((boundp 'temporary-file-directory) (directory-file-name temporary-file-directory)) (else "/tmp")) "/efs") "\
Template used to create temporary files.
If you are worried about security, make this a directory in some
bomb-proof cave somewhere. efs does clean up its temp files, but
they do live for short periods of time." :type 'string :group 'efs-parameters)

(defcustom efs-generate-anonymous-password t "\
*If t, use a password of `user@host' when logging in as the anonymous user.
`host' is generated by the function `efs-system-fqdn'. If `system name' returns
a fully qualified domain name, `efs-system-fqdn' will return this. Otherwise,
it will attempt to use nslookup to obtain a fully qualified domain name. If
this is unsuccessful, the returned value will be the same as `system-name',
whether this is a fully qualified domain name or not.

If a string then use that as the password.

If nil then prompt the user for a password.

Beware that some operating systems, such as MVS, restrict substantially
the password length. The login will fail with a weird error message
if you exceed it." :type '(choice (const t) string (const nil)) :group 'efs-behavior)

(defcustom efs-high-security-hosts nil "\
*Indicates host user pairs for which passwords should not be cached.
If non-nil, should be a regexp matching user@host constructions for which
efs should not store passwords in its internal cache." :type '(repeat (cons string string)) :group 'efs-parameters)

(defcustom efs-binary-file-name-regexp (concat "\\." "\\([zZ]\\|t?gz\\|bz2\\|lzh\\|arc\\|zip\\|zoo\\|ta[rz]\\|dvi\\|sit\\|" "ps\\|elc\\|gif\\|Z-part-..\\|tpz\\|exe\\|[jm]pg\\|TZ[a-z]?\\|lib\\)" "\\(~\\|~[0-9]+~\\)?$" "\\|" "\\." "\\(ARC\\|ELC\\|TAGS\\|EXE\\|ZIP\\|DVI|ZOO\\|GIF\\|T?GZ\\|" "[JM]PG\\)" "\\([.#;][0-9]+\\)?$") "\
*Files whose names  match this regexp will be considered to be binary.
By binary here, we mean 8-bit binary files (the usual unix binary files).
If nil, no files will be considered to be binary." :type '(repeat regexp) :group 'efs-parameters)

(defcustom efs-binary-file-host-regexp nil "\
*All files on hosts matching this regexp are treated as 8-bit binary.
Setting this to nil, inhibits this feature." :type '(choice (const nil) regexp) :group 'efs-parameters)

(defcustom efs-36-bit-binary-file-name-regexp nil "\
*Files whose names match this regexp will be considered to PDP 10 binaries.
These are 36-bit word-aligned binary files. This is really only relevant for
files on PDP 10's, and similar machines. If nil, no files will be considered
to be PDP 10 binaries." :type '(choice (const nil) regexp) :group 'efs-parameters)

(defcustom efs-text-file-name-regexp ".*" "\
*Files whose names match this regexp will be considered to be text files." :type '(choice (const nil) regexp) :group 'efs-parameters)

(defcustom efs-prompt-for-transfer-type nil "\
*If non-nil, efs will prompt for the transfer type for each file transfer.
The command efs-prompt-for-transfer-type can be used to toggle its value." :type 'boolean :group 'efs-behavior)

(defcustom efs-treat-crlf-as-nl nil "\
*Controls how file systems using CRLF as end of line are treated.
If non-nil, such file systems will be considered equivalent to those which use
LF as end of line.  This is particularly relevant to transfers between DOS
systems and UNIX.  Setting this to be non-nil will cause all file transfers
between DOS and UNIX systems to use be image or binary transfers." :type 'boolean :group 'efs-parameters)

(defcustom efs-send-hash t "\
*If non-nil, send the HASH command to the FTP client." :type 'boolean :group 'efs-parameters)

(defcustom efs-hash-mark-size nil "\
*Default size, in bytes, between hash-marks when transferring a file.
If this is nil then efs will attempt to assign a value based on the
output of the HASH command. Also, if this variable is incorrectly set,
then efs will try to correct it based on the size of the last file
transferred, and the number hashes outputed by the client during the
transfer.

The variable `efs-gateway-hash-mark-size' defines the corresponding value
for the FTP client on the gateway, if you are using a gateway.

Some client-server combinations do not correctly compute the number of hash
marks for incoming binary transfers. In this case, a separate variable
`efs-incoming-binary-hm-size' can be used to set a default value of the
hash mark size for incoming binary transfers." :type '(choice integer (const nil)) :group 'efs-parameters)

(defcustom efs-incoming-binary-hm-size nil "\
*Default hash mark size for incoming binary transfers.
If this is nil, incoming binary transfers will use `efs-hash-mark-size' as
the default. See the documentation of this variable for more details." :type '(choice integer (const nil)) :group 'efs-parameters)

(defcustom efs-verbose t "\
*If non-NIL then be chatty about interaction with the FTP process.
If 0 do not give % transferred reports for asynchronous commands and status
reports for commands verifying file modtimes, but report on everything else." :type 'boolean :group 'efs-behavior)

(defcustom efs-message-interval 0 "\
*Defines the minimum time in seconds between status messages.
A new status message is not displayed if one has already been given
within this period of time." :type 'integer :group 'efs-behavior)

(defcustom efs-max-ftp-buffer-size 3000 "\
*Maximum size in characters of FTP process buffer, before it is trimmed.
The buffer is trimmed to approximately half this size. Setting this to nil
inhibits trimming of FTP process buffers." :type 'integer :group 'efs-parameters)

(defcustom efs-ls-cache-max 5 "\
*Maximum number of directory listings to be cached in efs-ls-cache." :type 'integer :group 'efs-parameters)

(defcustom efs-mode-line-format " ftp(%d)" "\
Format string used to determine how FTP activity is shown on the mode line.
It is passed to format, with second argument the number of active FTP
sessions as an integer." :type 'string :group 'efs-behavior)

(defcustom efs-show-host-type-in-dired t "\
If non-nil, show the system type on the mode line of remote dired buffers." :type 'boolean :group 'efs-behavior)

(defcustom efs-ftp-activity-function nil "\
Function called to indicate FTP activity.
It must have exactly one argument, the number of active FTP sessions as an
integer." :type '(choice function (const nil)) :group 'efs-hooks)

(defcustom efs-ftp-program-name "ftp" "\
Name of FTP program to run." :type 'string :group 'efs-programs)

(defcustom efs-ftp-program-args '("-i" "-n" "-g" "-v") "\
*A list of arguments passed to the FTP program when started." :type '(repeat string) :group 'efs-programs)

(defcustom efs-ftp-prompt-regexp "^\\(ftp\\|Ftp\\|FTP\\)> *" "\
*Regular expression to match the prompt of your FTP client." :type 'regexp :group 'efs-programs)

(defcustom efs-ftp-flush-command (and (eq system-type 'windows-nt) "help help") "\
If non-NIL, get the FTP client to flush output by sending command." :type '(choice string (const nil)) :group 'efs-programs)

(defcustom efs-ftp-broken-quote nil "\
If non-NIL, double % characters in quote commands.
This works around a common bug in many BSD ftp client derivatives." :type 'boolean :group 'efs-programs)

(defcustom efs-ftp-explicit-empty-file-name (if (eq system-type 'berkeley-unix) "\" \"" "") "\
Quoted version of the empty file, if it needs to be specified explicitly.
Some ftp clients can't handle an empty file, but will accept a filename
consisting of a single space." :type 'string :group 'efs-programs)

(defcustom efs-nslookup-program (and (not (eq system-type 'windows-nt)) "nslookup") "\
*If non-NIL then a string naming the nslookup program." :type '(choice string (const nil)) :group 'efs-programs)

(defcustom efs-nslookup-on-connect nil "\
*If non-NIL then use nslookup to resolve the host name before connecting." :type 'boolean :group 'efs-programs)

(defcustom efs-nslookup-threshold 5000 "\
How many iterations efs waits on the nslookup program.
Applies when nslookup is used to compute a fully qualified domain name
for the local host, in the case when `system-name' does not return one.
If you set this to nil, efs will wait an arbitrary amount of time to get
output." :type 'integer :group 'efs-programs)

(defcustom efs-remote-shell-file-name (if (memq system-type '(hpux usg-unix-v)) "remsh" "rsh") "\
Remote shell used by efs." :type 'string :group 'efs-programs)

(defcustom efs-use-remote-shell-internally t "\
Set to non-nil if efs is to use remote shell commands internally.
If non-nil, efs will attempt to use remote shell commands to implement
certain commands the ftp server lacks such as chmod." :type 'boolean :group 'efs-programs)

(defcustom efs-remote-shell-takes-user (null (null (memq system-type '(aix aix-v3 hpux silicon-graphics-unix berkeley-unix)))) "\
Set to non-nil if your remote shell command takes \"-l USER\"." :type 'boolean :group 'efs-programs)

(defcustom efs-umask-command (and (not (eq system-type 'windows-nt)) "umask") "\
Shell command to print out umask." :type '(choice string (const nil)) :group 'efs-programs)

(defcustom efs-make-backup-files efs-unix-host-types "\
*A list of operating systems for which efs will make Emacs backup files.
The backup files are made on the remote host.

For example:
'(unix sysV-unix bsd-unix apollo-unix dumb-unix) makes sense, but
'(unix vms) would be silly, since vms makes its own backups." :type '(repeat symbol) :group 'efs-behavior)

(defcustom efs-backup-by-copying nil "\
*Version of `backup by copying' for remote files.
If non-nil, remote files will be backed up by copying, instead of by renaming.
Note the copying will be done by moving the file through the local host -- a
very time consuming operation." :type 'boolean :group 'efs-behavior)

(defcustom efs-auto-save 0 "\
*If 1, allows efs files to be auto-saved.
If 0, suppresses auto-saving of efs files.
Don't use any other value." :type '(choice (const 0) (const 1)) :group 'efs-auto-save)

(defcustom efs-auto-save-remotely nil "\
*Determines where remote files are auto-saved.

If nil, auto-saves for remote files will be written in `auto-save-directory'
or `auto-save-directory-fallback' if this isn't defined.

If non-nil, causes the auto-save file for an efs file to be written in
the remote directory containing the file, rather than in a local directory.
For remote files, this overrides a non-nil `auto-save-directory'. Local files
are unaffected. If you want to use this feature, you probably only want to
set this true in a few buffers, rather than globally.  You might want to give
each buffer its own value using `make-variable-buffer-local'. It is usually
a good idea to auto-save remote files locally, because it is not only faster,
but provides protection against a connection going down.

See also variable `efs-auto-save'." :type 'boolean :group 'efs-auto-save)

(defcustom efs-short-circuit (not (string-equal (expand-file-name "//") "//")) "\
*Defines whether expand-file-name and substitute-in-file-name short-circuit
\"//\" and \"/~\"." :type 'boolean :group 'efs-parameters)

(defcustom efs-short-circuit-to-remote-root nil "\
*Defines whether \"//\" short-circuits to the remote or local root." :type 'boolean :group 'efs-parameters)

(defcustom efs-local-apollo-unix (eq 0 (string-match "//" (or (getenv "HOME") (getenv "SHELL") ""))) "\
*Defines whether the local machine is an apollo running Domain.
This variable has nothing to do with efs, and should be basic to all
of emacs." :type 'boolean :group 'efs-parameters)

(defcustom efs-root-umask nil "\
*umask to use for root logins." :type '(choice integer (const nil)) :group 'efs-parameters)

(defcustom efs-anonymous-umask nil "\
*umask to use for anonymous logins." :type '(choice integer (const nil)) :group 'efs-parameters)

(defcustom efs-umask nil "\
*umask to use for efs sessions.
If this is nil, then the setting of umask on the local host is used." :type '(choice integer (const nil)) :group 'efs-parameters)

(defcustom efs-ding-on-umask-failure t "\
*Ring the bell if the umask command fails on a unix host. Many servers don't
support this command, so if you get a lot of annoying failures, set this
to nil." :type 'boolean :group 'efs-behavior)

(defcustom efs-ding-on-chmod-failure t "\
*Ring the bell if the chmod command fails on a unix host. Some servers don't
support this command, so if you get a lot of annoying failures, set this
to nil." :type 'boolean :group 'efs-behavior)

(defcustom efs-nlist-cmd (cond ((eq system-type 'berkeley-unix) "ls") ((memq system-type '(hpux aix-v3 silicon-graphics-unix)) "nlist") ("ls")) "\
*FTP client command for getting a brief listing (NLST) from the FTP server.
We try to guess this based on the local system-type, but obviously if you
are using a gateway, you'll have to set it yourself." :type 'string :group 'efs-programs)

(defcustom efs-quote-local-paths nil "\
*If non-nil, quote special characters of local path names in FTP commands.
Set this to non-nil if your FTP client expects local path names to be quoted.
This avoids the 'swallowing' of single backslashes." :type 'boolean :group 'efs-programs)

(defcustom efs-slash-local-paths nil "\
*If non-nil, always use slashes for local paths.
This is to support ftp clients that use a different separator
convention from that of the host Emacs." :type 'boolean :group 'efs-programs)

(defcustom efs-quote-local-paths nil "\
*If non-nil, quote special characters of local path names in FTP commands.
Set this to non-nil if your FTP client expects local path names to be quoted.
This avoids the 'swallowing' of single backslashes." :type 'boolean :group 'efs-programs)

(defcustom efs-compute-remote-buffer-file-truename nil "\
*If non-nil, `buffer-file-truename' will be computed for remote buffers.
In emacs 19, each buffer has a local variable, `buffer-file-truename',
which is used to ensure that symbolic links will not confuse emacs into
visiting the same file with two buffers. This variable is computed by
chasing all symbolic links in `buffer-file-name', both at the level of the
file and at the level of all parent directories. Since this operation can be
very time-consuming over FTP, this variable can be used to inhibit it." :type 'boolean :group 'efs-parameters)

(defcustom efs-buffer-name-case nil "\
*Selects the case used for buffer names of case-insensitive file names.
Case-insensitive file names are files on hosts whose host type is in
`efs-case-insensitive-host-types'.

If this is 'up upper case is used, if it is 'down lower case is used.
If this has any other value, the case is inherited from the name used
to access the file." :type '(choice (const nil) (const up) (const down)) :group 'efs-behavior)

(defcustom efs-fancy-buffer-names "%s@%s" "\
Format used to compute names of buffers attached to remote files.

If this is nil, buffer names are computed in the usual way.

If it is a string, then the it is passed to format with second and third
arguments the host name and file name.

Otherwise, it is assumed to be function taking three arguments, the host name,
the user name, and the truncated file name.  It should returns the name to
be used for the buffer." :type '(choice string function) :group 'efs-behavior)

(defcustom efs-verify-anonymous-modtime nil "\
*Determines if efs checks modtimes for remote files on anonymous logins.
If non-nil, efs runs `verify-visited-file-modtime' for remote files on
anonymous ftp logins. Since verify-visited-file-modtime slows things down,
and most people aren't editing files on anonymous ftp logins, this is nil
by default." :type 'boolean :group 'efs-parameters)

(defcustom efs-verify-modtime-host-regexp ".*" "\
*Regexp to match host names for which efs checks file modtimes.
If non-nil, efs will run `verify-visited-file-modtime' for remote
files on hosts matching this regexp. If nil, verify-visited-file-modtime
is supressed for all remote hosts. This is tested before
`efs-verify-anonymous-modtime'." :type 'regexp :group 'efs-parameters)

(defcustom efs-maximize-idle nil "\
*If non-nil, efs will attempt to maximize the idle time out period.
At some idle moment in the connection after login, efs will attempt to
set the idle time out period to the maximum amount allowed by the server.
It applies only to non-anonymous logins on unix hosts." :type 'boolean :group 'efs-parameters)

(defcustom efs-expire-ftp-buffers t "\
*If non-nil ftp buffers will be expired.
The buffers will be killed either after `efs-ftp-buffer-expire-time' has
elapsed with no activity, or the remote FTP server has timed out." :type 'boolean :group 'efs-parameters)

(defcustom efs-ftp-buffer-expire-time nil "\
*If non-nil, the time after which ftp buffers will be expired.
If nil, ftp buffers will be expired only when the remote server has timed out.
If an integer, ftp buffers will be expired either when the remote server
has timed out, or when this many seconds on inactivity has elapsed." :type '(choice (const nil) integer) :group 'efs-parameters)

(defcustom efs-retry-time 5 "\
*Number of seconds to wait before retrying if data doesn't arrive.
The FTP command isn't retried, rather efs just takes a second look
for the data file. This might need to be increased for very slow FTP
clients." :type 'integer :group 'efs-parameters)

(defcustom efs-pty-check-threshold 1000 "\
*How long efs waits before deciding that it doesn't have a pty.
Specifically it is the number of iterations through `accept-process-output'
that `efs-pty-p' waits before deciding that the pty is really a pipe.
Set this to nil to inhibit checking for pty's. If efs seems to be
mistaking some pty's for pipes, try increasing this number." :type 'integer :group 'efs-parameters)

(defcustom efs-pty-check-retry-time 5 "\
*Number of seconds that efs waits before retrying a pty check.
This can be lengthened, if your FTP client is slow to start." :type 'integer :group 'efs-parameters)

(defcustom efs-suppress-abort-recursive-edit-and-then nil "\
*If non-nil, `efs-abort-recursive-edit-and-then' will not run its function.
This means that when a recursive edit is in progress, automatic popping of the
FTP process buffer, and automatic popping of the bug report buffer will not
work. `efs-abort-recursive-edit-and-then' works by forking a \"sleep 0\"
process. On some unix implementations the forked process might be of the same
size as the original GNU Emacs process. Forking such a large process just to
do a \"sleep 0\" is probably not good." :type 'boolean :group 'efs-parameters)

(defcustom efs-ftp-buffer-format "*ftp %s@%s*" "\
Format to construct the name of FTP process buffers.
This string is fed to `format' with second and third arguments the user
name and host name." :type 'string :group 'efs-behavior)

(defcustom efs-debug-ftp-connection nil "\
*If non-nil, the user will be permitted to debug the FTP connection.
This means that typing a C-g to the FTP process filter will give the user
the option to type commands at the FTP connection.  Normally, the connection
is killed first.  Note that doing this may result in the FTP process filter
getting out of synch with the FTP client, so using this feature routinely
isn't recommended." :type 'boolean :group 'efs-behavior)

(defcustom efs-use-passive-mode nil "\
*If non-nil, the ftp client will specify passive mode for all transfers." :type 'boolean :group 'efs-parameters)

(defcustom efs-ftp-startup-hook nil "\
Hook to run immediately after starting the FTP client.
This hook is run before the FTP OPEN command is sent." :type 'hook :group 'efs-hooks)

(defcustom efs-ftp-startup-function-alist nil "\
Association list of functions to running after FTP login.
This should be an alist of the form '((REGEXP . FUNCTION) ...), where
REGEXP is a regular expression matched against the name of the remote host,
and FUNCTION is a function of two arguments, HOST and USER. REGEXP is
compared to the host name with `case-fold-search' bound to t. Only the first
match in the alist is run." :type '(repeat (cons regexp function)) :group 'efs-hooks)

(defcustom efs-load-hook nil "\
Hook to run immediately after loading efs.el.
You can use it to alter definitions in efs.el, but why would you want
to do such a thing?" :type 'hook :group 'efs-hooks)

;;;***

(provide 'efs-custom-defines)
